/*
 *
 * This program is written by
 * Vincent Guerin
 * and Ludovic Rousseau <ludovic.rousseau@gemplus.com>
 *
 * $Id: interface.c,v 1.3 2002/03/12 09:13:57 rousseau Exp $
 *
 */

/*
 * Copyright  2000 Gemplus
 * Av. du Pic de Bertagne - Parc d'Activits de Gmenos
 * BP 100 - 13881 Gmenos CEDEX
 * 
 * Everyone is allowed to redistribute and use this source  (source
 * code)  and binary (object code),  with or  without modification,
 * under some conditions:
 * 
 *  - Everyone  must  retain  and/or  reproduce the above copyright
 *    notice,  and the below  disclaimer of warranty and limitation
 *    of liability  for redistribution and use of these source code
 *    and object code.
 * 
 *  - Everyone  must  ask a  specific prior written permission from
 *    Gemplus to use the name of Gemplus.
 * 
 * DISCLAIMER OF WARRANTY
 * 
 * THIS CODE IS PROVIDED "AS IS",  WITHOUT ANY WARRANTY OF ANY KIND
 * (INCLUDING,  BUT  NOT  LIMITED  TO,  THE IMPLIED  WARRANTIES  OF
 * MERCHANTABILITY  AND FITNESS FOR  A  PARTICULAR PURPOSE)  EITHER
 * EXPRESS OR IMPLIED.  GEMPLUS DOES NOT WARRANT THAT THE FUNCTIONS
 * CONTAINED  IN THIS SOFTWARE WILL MEET THE USER'S REQUIREMENTS OR
 * THAT THE OPERATION OF IT WILL BE UNINTERRUPTED OR ERROR-FREE. NO
 * USE  OF  ANY  CODE  IS  AUTHORIZED  HEREUNDER EXCEPT UNDER  THIS
 * DISCLAIMER.
 * 
 * LIMITATION OF LIABILITY
 * 
 * GEMPLUS SHALL NOT BE LIABLE FOR INFRINGEMENTS OF  THIRD  PARTIES
 * RIGHTS. IN NO EVENTS, UNLESS REQUIRED BY APPLICABLE  LAW,  SHALL
 * GEMPLUS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES OF ANY CHARACTER  INCLUDING,
 * WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK STOPPAGE,
 * COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL OTHER DAMAGES OR
 * LOSSES, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. ALSO,
 * GEMPLUS IS  UNDER NO  OBLIGATION TO MAINTAIN,  CORRECT,  UPDATE,
 * CHANGE, MODIFY, OR OTHERWISE SUPPORT THIS SOFTWARE.
 */
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "config.h"
#include "global.h"

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#define VERSION "2.1"

/* XPM */
static char *xpm_gemplus_horiz[] = {
/* width height num_colors chars_per_pixel */
"   189    35       30            1",
/* colors */
". c #000000",
"# c #101010",
"a c #212121",
"b c #313131",
"c c #424242",
"d c #4ab5ff",
"e c #525252",
"f c #5a5a63",
"g c #5a94bd",
"h c #636363",
"i c #63bdff",
"j c #6bc6ff",
"k c #737373",
"l c #7b7b7b",
"m c #7bc6ff",
"n c #8c8c8c",
"o c #9c9c9c",
"p c #9cd6ff",
"q c #a5deff",
"r c #adadad",
"s c #b5deff",
"t c #bdbdbd",
"u c #c6e7ff",
"v c #cecece",
"w c #d6efff",
"x c #dedede",
"y c #def7ff",
"z c #efefef",
"A c #eff7ff",
"B c #ffffff",
/* pixels */
"BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBBBBBBBBBBr....BBBBBBBBBgBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBBBBBBBBB.......BBBBBBgggBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBBBBBBBB...BBB...BBBggggBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBBBBBBBc..BBBBBr..BgggBAgBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBBBBBBB..BBBBBBB...gBBgggBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBBBBBB...BBBBBBgg..BggggBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBBBBBB..BBBBBBggB..ggggBgBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBBBBBB..BBBBggggB...gBiggBBBBBBBBBBBBBBBBBBB.......zBBBBBBB.................BB....xBBBBBBBBBBB....BBBcccccccccccclBBBBBBB...BBBBBBBBBBBBBBB....BBBBBBBBBBB....BBBBBBBB.......nBBBBBBBBBB",
"BBBBBBBBBB...BBggggBBBB..ugpgABBBBBBBBBBBBBBBB#............BBBBB.................BB.....BBBBBBBBBB.....BBB...............BBBBB...BBBBBBBBBBBBBBB....BBBBBBBBBBB....BBBBB.............cBBBBBBB",
"BBBBBBBBBB..#qgggBBggBB..gBBB.BBBBBBBBBBBBBBB................BBB.................BB......BBBBBBBBB.....BBB................tBBB...BBBBBBBBBBBBBBB....BBBBBBBBBBB....BBBB................BBBBBB",
"BBBBBBBBBB..gggABggggBB..BB...BBBBBBBBBBBBBB.....BBBBBBBh...BBBB....BBBBBBBBBBBBBBB......BBBBBBBB......BBB....BBBBBBBB.....BBB...BBBBBBBBBBBBBBB....BBBBBBBBBBB....BBB.....BBBBBBBB....#BBBBB",
"BBBBBBBBBBggggBggggBsmBeB#...BBBBBBBBBBBBBo....BBBBBBBBBBB.zBBBB....BBBBBBBBBBBBBBB.......BBBBBBB......BBB....BBBBBBBBB....BBB...BBBBBBBBBBBBBBB....BBBBBBBBBBB....BBB....BBBBBBBBBBB.#BBBBBB",
"BBBBBBBBggggBggggBBgmBBB...xBgBBBBBBBBBBBB....BBBBBBBBBBBBBBBBBB....BBBBBBBBBBBBBBB.......BBBBBB.......BBB....BBBBBBBBBo...BBB...BBBBBBBBBBBBBBB....BBBBBBBBBBB....BBB....BBBBBBBBBBBBBBBBBBB",
"BBBBBBBggggBggggBAgBBBf...BBggBBBBBBBBBBBB...BBBBBBBBBBBBBBBBBBB....BBBBBBBBBBBBBBB........BBBB........BBB....BBBBBBBBB....BBB...BBBBBBBBBBBBBBB....BBBBBBBBBBB....BBB.....BBBBBBBBBBBBBBBBBB",
"BBBBBBgggBjgggBBgiBBB.....ggggBBBBBBBBBBB....BBBBBBBBBBBBBBBBBBB.............BBBBBB.........BBB....B...BBB....BB...........BBB...BBBBBBBBBBBBBBB....BBBBBBBBBBB....BBB.............BBBBBBBBBB",
"BBBBBBgBwgggBBgggBB...aB..ggBpBBBBBBBBBBB....BBBBBBBlllllllllBBB.............BBBBBB....B....BB....kB...BBB....BB..........BBBB...BBBBBBBBBBBBBBB....BBBBBBBBBBB....BBBBk.............lBBBBBBB",
"BBBBBBBgggwBggggBBB..BBB..BAggBBBBBBBBBBB....BBBBBBB.........BBB.............BBBBBB....BB....l....BB...BBB....BB.........BBBBB...BBBBBBBBBBBBBBB....BBBBBBBBBBB....BBBBBBa.............BBBBBB",
"BBBBBBggmBggggBwgggBBgBB..ggggBBBBBBBBBBB....BBBBBBB.........BBB....BBBBBBBBBBBBBBB....BB........BBB...BBB....BBBBBBBBBBBBBBBB...BBBBBBBBBBBBBBB....BBBBBBBBBBB....BBBBBBBBBBBBBt......BBBBBB",
"BBBBBBgBigggBBgggpBggwBB..ggBBBBBBBBBBBBBB...tBBBBBBBBBBBB...BBB....BBBBBBBBBBBBBBB....BBB.......BBB...BBB....BBBBBBBBBBBBBBBB...BBBBBBBBBBBBBBB....BBBBBBBBBBB....BBBBBBBBBBBBBBBB....rBBBBB",
"BBBBBBBgggBBggggBggggBBo.dBBBBBBBBBBBBBBBB.....BBBBBBBBBBB...BBB....BBBBBBBBBBBBBBB....BBB......BBBB...BBB....BBBBBBBBBBBBBBBB...BBBBBBBBBBBBBBB....BBBBBBBBBBB....BBB..BBBBBBBBBBBx....BBBBB",
"BBBBBBgggBBgggBBggguBBB..BBBBBBBBBBBBBBBBBB....BBBBBBBBBBB...BBB....BBBBBBBBBBBBBBB....BBBx.....BBBB...BBB....BBBBBBBBBBBBBBBB...BBBBBBBBBBBBBBBh...aBBBBBBBBBb...cBBB...BBBBBBBBBB....oBBBBB",
"BBBBBBgBBggggBggggBgggg..BBBBBBBBBBBBBBBBBBB.....zBBBBBB.....BBB....BBBBBBBBBBBBBBB....BBBB....BBBBB...BBB....BBBBBBBBBBBBBBBB................BBB.....nBBBBBn.....BBB.......BBBBB......BBBBBB",
"BBBBBBBggggBsgggBBgggBB..BBBBBBBBBBBBBBBBBBBB................BBB.................BB....BBBBB...BBBBB...BBB....BBBBBBBBBBBBBBBB................BBBo...............oBBBB................BBBBBBB",
"BBBBBBgggBBgggBBgggBBBe..BBBBBBBBBBBBBBBBBBBBBz............BBBBB.................BB....BBBBBl.BBBBBB...BBB....BBBBBBBBBBBBBBBB................BBBBB.............BBBBBBBB............aBBBBBBBB",
"BBBBBBgBBgggpBggggBBBB..nBBBBBBBBBBBBBBBBBBBBBBBBl......BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBr.....oBBBBBBBBBBBBBBBk...cBBBBBBBBBBBB",
"BBBBBBBggggBggggBBBBBB..BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBgggBpgggBBBBBBB...BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBggBmggg.BBBBBBB..zBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBBwgggBB..vBBBB...BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBgggyBBB....r....BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBgmBBBBBB.......BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBBBBBBBBBBB...BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB"
};

GtkWidget *create_mainWindow(void)
{
	GdkPixmap *gdk_pixmap;
	GdkBitmap *mask;
	GdkColormap *colormap;

	GtkWidget *pixmap;

	GtkWidget *hbuttonbox1;
	GtkWidget *hbuttonbox3;
	GtkWidget *hbuttonbox4;
	GtkWidget *hbuttonbox5;
	GtkWidget *vbuttonbox6;
	GtkWidget *hbuttonbox7;
	GtkWidget *hbuttonbox8;

	GtkWidget *master1;

	GtkWidget *vbox1;
	GtkWidget *vbox2;
	GtkWidget *vbox3;
	GtkWidget *vbox4;
	GtkWidget *vbox5;
	GtkWidget *vbox6;
	GtkWidget *vbox7;

	GtkWidget *label1;
	GtkWidget *label2;
	GtkWidget *label3;
	GtkWidget *label4;
	GtkWidget *label5;
	GtkWidget *label6;
	GtkWidget *label7;
	GtkWidget *label8;

	GtkWidget *frame1;
	GtkWidget *frame2;
	GtkWidget *frame3;
	GtkWidget *frame4;

	GtkWidget *alignment1;
	GtkWidget *alignment2;
	GtkWidget *alignment3;
	GtkWidget *alignment4;

	GtkWidget *hseparator1;

	GtkWidget *aspectframe1;
	GtkWidget *aspectframe2;
	GtkWidget *aspectframe3;

	GtkWidget *button1;
	GtkWidget *button2;
	GtkWidget *button3;
	GtkWidget *button4;
	GtkWidget *button5;
	GtkWidget *button6;
	GtkWidget *button7;
	GtkWidget *button8;

	GtkWidget *scrolledwindow1;

	mainWindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_object_set_data(GTK_OBJECT(mainWindow), "mainWindow", mainWindow);
	gtk_window_set_title(GTK_WINDOW(mainWindow), _("Smart Session tools"));
	gtk_window_set_position(GTK_WINDOW(mainWindow), GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(mainWindow), FALSE, FALSE, FALSE);

	master1 = gtk_notebook_new();
	gtk_widget_ref(master1);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "master1", master1,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(master1);
	gtk_container_add(GTK_CONTAINER(mainWindow), master1);

	///////////////////////////// 
	// First page: Manage Card //
	/////////////////////////////

	vbox1 = gtk_vbox_new(FALSE, 0);
	gtk_widget_ref(vbox1);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "vbox1", vbox1,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(vbox1);
	gtk_container_add(GTK_CONTAINER(master1), vbox1);

	vbox2 = gtk_vbox_new(FALSE, 0);
	gtk_widget_ref(vbox2);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "vbox2", vbox2,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(vbox2);
	gtk_box_pack_start(GTK_BOX(vbox1), vbox2, TRUE, TRUE, 0);

	/* now for the pixmap from gdk */
	colormap = gtk_widget_get_colormap(mainWindow);
	gdk_pixmap = gdk_pixmap_colormap_create_from_xpm_d(NULL, colormap, &mask,
		NULL, xpm_gemplus_horiz);

	/* a pixmap widget to contain the pixmap */
	pixmap = gtk_pixmap_new(gdk_pixmap, mask);

	gtk_widget_ref(pixmap);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "pixmap", pixmap,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(pixmap);
	gtk_box_pack_start(GTK_BOX(vbox2), pixmap, FALSE, TRUE, 0);

	frame2 = gtk_frame_new(_("Format a new card"));
	gtk_widget_ref(frame2);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "frame2", frame2,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(frame2);
	gtk_box_pack_start(GTK_BOX(vbox2), frame2, TRUE, TRUE, 6);

	alignment1 = gtk_alignment_new(0.5, 0.5, 1, 1);
	gtk_widget_ref(alignment1);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "alignment1", alignment1,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(alignment1);
	gtk_container_add(GTK_CONTAINER(frame2), alignment1);

	hbuttonbox4 = gtk_hbutton_box_new();
	gtk_widget_ref(hbuttonbox4);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "hbuttonbox4",
		hbuttonbox4, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(hbuttonbox4);
	gtk_container_add(GTK_CONTAINER(alignment1), hbuttonbox4);

	button4 = gtk_button_new_with_label(_("Ok"));
	gtk_widget_ref(button4);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "button4", button4,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(button4);
	gtk_container_add(GTK_CONTAINER(hbuttonbox4), button4);
	GTK_WIDGET_SET_FLAGS(button4, GTK_CAN_DEFAULT);

	hseparator1 = gtk_hseparator_new();
	gtk_widget_ref(hseparator1);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "hseparator1",
		hseparator1, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(hseparator1);
	gtk_box_pack_start(GTK_BOX(vbox2), hseparator1, TRUE, TRUE, 0);

	frame1 = gtk_frame_new(_("Change Pin / Unlock Card"));
	gtk_widget_ref(frame1);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "frame1", frame1,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(frame1);
	gtk_box_pack_start(GTK_BOX(vbox2), frame1, TRUE, TRUE, 6);

	vbox3 = gtk_vbox_new(FALSE, 0);
	gtk_widget_ref(vbox3);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "vbox3", vbox3,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(vbox3);
	gtk_container_add(GTK_CONTAINER(frame1), vbox3);

	label4 = gtk_label_new(_("Enter the new user PIN code twice"));
	gtk_widget_ref(label4);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "label4", label4,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(label4);
	gtk_box_pack_start(GTK_BOX(vbox3), label4, FALSE, FALSE, 6);

	aspectframe1 = gtk_aspect_frame_new(NULL, 0.5, 0.5, 1, TRUE);
	gtk_widget_ref(aspectframe1);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "aspectframe1",
		aspectframe1, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(aspectframe1);
	gtk_box_pack_start(GTK_BOX(vbox3), aspectframe1, FALSE, FALSE, 8);

	entry7 = gtk_entry_new();
	gtk_widget_ref(entry7);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "entry7", entry7,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_entry_set_visibility((GtkEntry *) entry7, 0);
	gtk_widget_show(entry7);
	gtk_container_add(GTK_CONTAINER(aspectframe1), entry7);

	aspectframe3 = gtk_aspect_frame_new(NULL, 0.5, 0.5, 1, TRUE);
	gtk_widget_ref(aspectframe3);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "aspectframe3",
		aspectframe3, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(aspectframe3);
	gtk_box_pack_start(GTK_BOX(vbox3), aspectframe3, TRUE, TRUE, 6);

	entry9 = gtk_entry_new();
	gtk_widget_ref(entry9);
	gtk_entry_set_visibility((GtkEntry *) entry9, 0);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "entry9", entry9,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(entry9);
	gtk_container_add(GTK_CONTAINER(aspectframe3), entry9);

	alignment2 = gtk_alignment_new(0.5, 0.5, 1, 1);
	gtk_widget_ref(alignment2);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "alignment2", alignment2,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(alignment2);
	gtk_box_pack_start(GTK_BOX(vbox3), alignment2, TRUE, TRUE, 0);

	hbuttonbox5 = gtk_hbutton_box_new();
	gtk_widget_ref(hbuttonbox5);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "hbuttonbox5",
		hbuttonbox5, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(hbuttonbox5);
	gtk_container_add(GTK_CONTAINER(alignment2), hbuttonbox5);

	button5 = gtk_button_new_with_label(_("Ok"));
	gtk_widget_ref(button5);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "button5", button5,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(button5);
	gtk_container_add(GTK_CONTAINER(hbuttonbox5), button5);
	GTK_WIDGET_SET_FLAGS(button5, GTK_CAN_DEFAULT);

	label1 = gtk_label_new(_("Manage \nCard"));
	gtk_widget_ref(label1);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "label1", label1,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(label1);
	gtk_notebook_set_tab_label(GTK_NOTEBOOK(master1),
		gtk_notebook_get_nth_page(GTK_NOTEBOOK(master1), 0), label1);

	///////////////////////////////
	// Second page: Manage Users //
	///////////////////////////////

	vbox4 = gtk_vbox_new(FALSE, 0);
	gtk_widget_ref(vbox4);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "vbox4", vbox4,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(vbox4);
	gtk_container_add(GTK_CONTAINER(master1), vbox4);

	pixmap = gtk_pixmap_new(gdk_pixmap, mask);
	gtk_widget_show(pixmap);
	gtk_box_pack_start(GTK_BOX(vbox4), pixmap, FALSE, TRUE, 0);

	label5 = gtk_label_new(_("Enter the user name"));
	gtk_widget_ref(label5);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "label5", label5,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(label5);
	gtk_box_pack_start(GTK_BOX(vbox4), label5, FALSE, FALSE, 3);

	aspectframe2 = gtk_aspect_frame_new(NULL, 0.5, 0.5, 1, TRUE);
	gtk_widget_ref(aspectframe2);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "aspectframe2",
		aspectframe2, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(aspectframe2);
	gtk_box_pack_start(GTK_BOX(vbox4), aspectframe2, FALSE, FALSE, 3);

	entry8 = gtk_entry_new();
	gtk_widget_ref(entry8);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "entry8", entry8,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(entry8);
	gtk_container_add(GTK_CONTAINER(aspectframe2), entry8);

	hbuttonbox1 = gtk_hbutton_box_new();
	gtk_widget_ref(hbuttonbox1);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "hbuttonbox1",
		hbuttonbox1, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(hbuttonbox1);
	gtk_box_pack_start(GTK_BOX(vbox4), hbuttonbox1, FALSE, TRUE, 3);

	button1 = gtk_button_new_with_label(_("Create"));
	gtk_widget_ref(button1);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "button1", button1,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(button1);
	gtk_container_add(GTK_CONTAINER(hbuttonbox1), button1);
	GTK_WIDGET_SET_FLAGS(button1, GTK_CAN_DEFAULT);

	button2 = gtk_button_new_with_label(_("Delete"));
	gtk_widget_ref(button2);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "button2", button2,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(button2);
	gtk_container_add(GTK_CONTAINER(hbuttonbox1), button2);
	GTK_WIDGET_SET_FLAGS(button2, GTK_CAN_DEFAULT);

	button3 = gtk_button_new_with_label(_("Verify"));
	gtk_widget_ref(button3);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "button3", button3,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(button3);
	gtk_container_add(GTK_CONTAINER(hbuttonbox1), button3);
	GTK_WIDGET_SET_FLAGS(button3, GTK_CAN_DEFAULT);

	scrolledwindow1 = gtk_scrolled_window_new(NULL, NULL);
	gtk_widget_ref(scrolledwindow1);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "scrolledwindow1",
		scrolledwindow1, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(scrolledwindow1);
	gtk_box_pack_start(GTK_BOX(vbox4), scrolledwindow1, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow1),
		GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

	clist1 = gtk_clist_new(1);
	gtk_widget_ref(clist1);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "clist1", clist1,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(clist1);
	gtk_container_add(GTK_CONTAINER(scrolledwindow1), clist1);

	label2 = gtk_label_new(_("Manage \nUsers"));
	gtk_widget_ref(label2);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "label2", label2,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(label2);
	gtk_notebook_set_tab_label(GTK_NOTEBOOK(master1),
		gtk_notebook_get_nth_page(GTK_NOTEBOOK(master1), 1), label2);

	//////////////////////////////////////
	// Third page: Manage Certification //
	//////////////////////////////////////

	vbox6 = gtk_vbox_new(FALSE, 0);
	gtk_widget_ref(vbox6);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "vbox6", vbox6,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(vbox6);
	gtk_container_add(GTK_CONTAINER(master1), vbox6);

	pixmap = gtk_pixmap_new(gdk_pixmap, mask);
	gtk_widget_show(pixmap);
	gtk_box_pack_start(GTK_BOX(vbox6), pixmap, FALSE, TRUE, 0);

	frame3 = gtk_frame_new(_("Create administrator certification card"));
	gtk_widget_ref(frame3);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "frame3", frame3,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(frame3);
	gtk_box_pack_start(GTK_BOX(vbox6), frame3, TRUE, TRUE, 6);

	alignment3 = gtk_alignment_new(0.5, 0.5, 1, 1);
	gtk_widget_ref(alignment1);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "alignment3", alignment3,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(alignment3);
	gtk_container_add(GTK_CONTAINER(frame3), alignment3);

	hbuttonbox7 = gtk_hbutton_box_new();
	gtk_widget_ref(hbuttonbox7);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "hbuttonbox7",
		hbuttonbox7, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(hbuttonbox7);
	gtk_container_add(GTK_CONTAINER(alignment3), hbuttonbox7);

	button7 = gtk_button_new_with_label(_("Ok"));
	gtk_widget_ref(button7);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "button7", button7,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(button7);
	gtk_container_add(GTK_CONTAINER(hbuttonbox7), button7);
	GTK_WIDGET_SET_FLAGS(button7, GTK_CAN_DEFAULT);

	frame4 = gtk_frame_new(_("Install the certification public key"));
	gtk_widget_ref(frame4);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "frame4", frame4,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(frame4);
	gtk_box_pack_start(GTK_BOX(vbox6), frame4, TRUE, TRUE, 6);

	alignment4 = gtk_alignment_new(0.5, 0.5, 1, 1);
	gtk_widget_ref(alignment4);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "alignment4", alignment4,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(alignment4);
	gtk_container_add(GTK_CONTAINER(frame4), alignment4);

	hbuttonbox8 = gtk_hbutton_box_new();
	gtk_widget_ref(hbuttonbox8);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "hbuttonbox8",
		hbuttonbox8, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(hbuttonbox8);
	gtk_container_add(GTK_CONTAINER(alignment4), hbuttonbox8);

	button8 = gtk_button_new_with_label(_("Ok"));
	gtk_widget_ref(button8);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "button8", button8,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(button8);
	gtk_container_add(GTK_CONTAINER(hbuttonbox8), button8);
	GTK_WIDGET_SET_FLAGS(button8, GTK_CAN_DEFAULT);

	label6 = gtk_label_new(_("Manage \nCertification"));
	gtk_widget_ref(label6);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "label6", label6,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(label6);
	gtk_notebook_set_tab_label(GTK_NOTEBOOK(master1),
		gtk_notebook_get_nth_page(GTK_NOTEBOOK(master1), 2), label6);

	/////////////////////
	// Next page: Quit //
	/////////////////////

	vbox5 = gtk_vbox_new(FALSE, 0);
	gtk_widget_ref(vbox5);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "vbox5", vbox5,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(vbox5);
	gtk_container_add(GTK_CONTAINER(master1), vbox5);

	pixmap = gtk_pixmap_new(gdk_pixmap, mask);
	gtk_widget_show(pixmap);
	gtk_box_pack_start(GTK_BOX(vbox5), pixmap, FALSE, TRUE, 0);

	vbuttonbox6 = gtk_vbutton_box_new();
	gtk_widget_ref(vbuttonbox6);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "vbuttonbox6",
		vbuttonbox6, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(vbuttonbox6);
	gtk_box_pack_start(GTK_BOX(vbox5), vbuttonbox6, FALSE, FALSE, 0);

	button6 = gtk_button_new_with_label(_("Quit"));
	gtk_widget_ref(button6);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "button6", button6,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(button6);
	gtk_container_add(GTK_CONTAINER(vbuttonbox6), button6);
	GTK_WIDGET_SET_FLAGS(button6, GTK_CAN_DEFAULT);

	hbuttonbox3 = gtk_hbutton_box_new();
	gtk_widget_ref(hbuttonbox3);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "hbuttonbox3",
		hbuttonbox3, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(hbuttonbox3);
	gtk_box_pack_start(GTK_BOX(vbox5), hbuttonbox3, FALSE, FALSE, 32);

	label3 = gtk_label_new(_("  Quit  "));
	gtk_widget_ref(label3);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "label3", label3,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(label3);
	gtk_notebook_set_tab_label(GTK_NOTEBOOK(master1),
		gtk_notebook_get_nth_page(GTK_NOTEBOOK(master1), 3), label3);

	////////////////////////////
	// Next page: Information //
	////////////////////////////

	vbox7 = gtk_vbox_new(FALSE, 0);
	gtk_widget_ref(vbox7);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "vbox7", vbox7,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(vbox7);
	gtk_container_add(GTK_CONTAINER(master1), vbox7);

	pixmap = gtk_pixmap_new(gdk_pixmap, mask);
	gtk_widget_show(pixmap);
	gtk_box_pack_start(GTK_BOX(vbox7), pixmap, FALSE, TRUE, 0);

	label8 = gtk_label_new(_("\nxsst " VERSION " Mar 2002"
		"\n\nX SmartSession tool by Vincent Guerin\n" \
		"\n" \
		"Utilities for management of PAM smart card module\n" \
		"and CFS for smartcard applications\n" \
		"\n" \
		"Send bug report to Ludovic ROUSSEAU\n" \
		"<ludovic.rousseau@gemplus.com>\n"));
	gtk_widget_ref(label8);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "label8", label8,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(label8);
	gtk_box_pack_start(GTK_BOX(vbox7), label8, FALSE, FALSE, 0);

	label7 = gtk_label_new(_("Informations"));
	gtk_widget_ref(label7);
	gtk_object_set_data_full(GTK_OBJECT(mainWindow), "label7", label7,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(label7);
	gtk_notebook_set_tab_label(GTK_NOTEBOOK(master1),
		gtk_notebook_get_nth_page(GTK_NOTEBOOK(master1), 4), label7);

	gtk_signal_connect(GTK_OBJECT(button4), "clicked",
		GTK_SIGNAL_FUNC(on_button_format_clicked), NULL);
	gtk_signal_connect(GTK_OBJECT(button5), "clicked",
		GTK_SIGNAL_FUNC(on_button_change_pin_clicked), NULL);
	gtk_signal_connect(GTK_OBJECT(button1), "clicked",
		GTK_SIGNAL_FUNC(on_button_create_user_clicked), NULL);
	gtk_signal_connect(GTK_OBJECT(button2), "clicked",
		GTK_SIGNAL_FUNC(on_button_delete_user_clicked), NULL);
	gtk_signal_connect(GTK_OBJECT(button3), "clicked",
		GTK_SIGNAL_FUNC(on_button_verify_clicked), NULL);
	gtk_signal_connect(GTK_OBJECT(button6), "clicked",
		GTK_SIGNAL_FUNC(on_button_quit_clicked), NULL);
	gtk_signal_connect(GTK_OBJECT(button7), "clicked",
		GTK_SIGNAL_FUNC(on_button_create_cert_card_clicked), NULL);
	gtk_signal_connect(GTK_OBJECT(button8), "clicked",
		GTK_SIGNAL_FUNC(on_button_install_cert_key_clicked), NULL);
	gtk_signal_connect(GTK_OBJECT(mainWindow), "destroy",
		GTK_SIGNAL_FUNC(on_button_quit_clicked), NULL);
	gtk_signal_connect(GTK_OBJECT(master1), "switch_page",
		GTK_SIGNAL_FUNC(on_master1_switch_page), NULL);
	gtk_signal_connect(GTK_OBJECT(clist1), "select_row",
		GTK_SIGNAL_FUNC(on_clist1_selection_made), NULL);

	gtk_widget_show(mainWindow);

	return mainWindow;
}

GtkWidget *create_firstWindow(void)
{
	GdkPixmap *gdk_pixmap;
	GdkBitmap *mask;
	GdkColormap *colormap;
	GtkWidget *pixmap;
	GtkWidget *vbox12;
	GtkWidget *label19;
	GtkWidget *aspectframe8;
	GtkWidget *label20;
	GtkWidget *aspectframe9;
	GtkWidget *frame4;
	GtkWidget *frame5;
	GtkWidget *vbox13;
	GtkWidget *vbox6;
	GtkWidget *aspectframe10;
	GtkWidget *hbuttonbox10;
	GtkWidget *button37;
	GtkWidget *button38;

	firstWindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_widget_ref(firstWindow);
	gtk_window_set_title(GTK_WINDOW(firstWindow), _("Smart Session tools"));
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "firstWindow",
		firstWindow, (GtkDestroyNotify) gtk_widget_unref);
	gtk_window_set_position(GTK_WINDOW(firstWindow), GTK_WIN_POS_MOUSE);
	gtk_window_set_default_size(GTK_WINDOW(firstWindow), 265, 290);

	vbox12 = gtk_vbox_new(FALSE, 0);
	gtk_widget_ref(vbox12);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "vbox12", vbox12,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(vbox12);
	gtk_container_add(GTK_CONTAINER(firstWindow), vbox12);

	/* now for the pixmap from gdk */
	colormap = gtk_widget_get_colormap(firstWindow);
	gdk_pixmap = gdk_pixmap_colormap_create_from_xpm_d(NULL, colormap, &mask,
		NULL, xpm_gemplus_horiz);

	/* a pixmap widget to contain the pixmap */
	pixmap = gtk_pixmap_new(gdk_pixmap, mask);
	gtk_widget_show(pixmap);
	gtk_box_pack_start(GTK_BOX(vbox12), pixmap, FALSE, TRUE, 0);

	label19 = gtk_label_new(_("Enter your passphrase"));
	gtk_widget_ref(label19);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "label19", label19,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(label19);
	gtk_box_pack_start(GTK_BOX(vbox12), label19, FALSE, FALSE, 3);

	aspectframe8 = gtk_aspect_frame_new(NULL, 0.5, 0.5, 1, TRUE);
	gtk_widget_ref(aspectframe8);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "aspectframe8",
		aspectframe8, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(aspectframe8);
	gtk_box_pack_start(GTK_BOX(vbox12), aspectframe8, FALSE, FALSE, 3);

	entry10 = gtk_entry_new_with_max_length((guint16) PASSPHRASE_MAX_LEN);
	gtk_widget_ref(entry10);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "entry10", entry10,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_entry_set_visibility((GtkEntry *) entry10, 0);
	gtk_widget_show(entry10);
	gtk_container_add(GTK_CONTAINER(aspectframe8), entry10);

	label20 = gtk_label_new(_("Re-enter your passphrase"));
	gtk_widget_ref(label20);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "label20", label20,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(label20);
	gtk_box_pack_start(GTK_BOX(vbox12), label20, FALSE, FALSE, 3);

	aspectframe9 = gtk_aspect_frame_new(NULL, 0.5, 0.5, 1, TRUE);
	gtk_widget_ref(aspectframe9);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "aspectframe9",
		aspectframe9, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(aspectframe9);
	gtk_box_pack_start(GTK_BOX(vbox12), aspectframe9, FALSE, FALSE, 3);

	entry11 = gtk_entry_new_with_max_length((guint16) PASSPHRASE_MAX_LEN);
	gtk_widget_ref(entry11);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "entry11", entry11,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_entry_set_visibility((GtkEntry *) entry11, 0);
	gtk_widget_show(entry11);
	gtk_container_add(GTK_CONTAINER(aspectframe9), entry11);

	frame4 = gtk_frame_new(_("Public key destination"));
	gtk_widget_ref(frame4);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "frame4", frame4,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(frame4);
	gtk_box_pack_start(GTK_BOX(vbox12), frame4, TRUE, TRUE, 0);

	vbox13 = gtk_vbox_new(FALSE, 0);
	gtk_widget_ref(vbox13);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "vbox13", vbox13,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(vbox13);
	gtk_container_add(GTK_CONTAINER(frame4), vbox13);

	aspectframe10 = gtk_aspect_frame_new(NULL, 0.5, 0.5, 1, TRUE);
	gtk_widget_ref(aspectframe10);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "aspectframe10",
		aspectframe10, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(aspectframe10);
	gtk_box_pack_start(GTK_BOX(vbox13), aspectframe10, TRUE, TRUE, 2);

	entry12 = gtk_entry_new();
	gtk_widget_ref(entry12);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "entry12", entry12,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_entry_set_text(GTK_ENTRY(entry12), _(DEFAULT_DB_NAME));
	gtk_widget_show(entry12);
	gtk_container_add(GTK_CONTAINER(aspectframe10), entry12);

	frame5 = gtk_frame_new(_("Are there two readers"));
	gtk_widget_ref(frame5);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "frame5", frame5,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(frame5);
	gtk_box_pack_start(GTK_BOX(vbox12), frame5, TRUE, TRUE, 0);

	vbox6 = gtk_vbox_new(FALSE, 0);
	gtk_widget_ref(vbox6);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "vbox6", vbox6,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(vbox6);
	gtk_container_add(GTK_CONTAINER(frame5), vbox6);

	checkbutton1 = gtk_check_button_new_with_label(_("Yes"));
	gtk_widget_ref(checkbutton1);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "checkbutton1",
		checkbutton1, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(checkbutton1);
	gtk_box_pack_start(GTK_BOX(vbox6), checkbutton1, FALSE, FALSE, 0);

	hbuttonbox10 = gtk_hbutton_box_new();
	gtk_widget_ref(hbuttonbox10);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "hbuttonbox10",
		hbuttonbox10, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(hbuttonbox10);
	gtk_box_pack_start(GTK_BOX(vbox12), hbuttonbox10, TRUE, TRUE, 0);

	button37 = gtk_button_new_with_label(_("Ok"));
	gtk_widget_ref(button37);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "button37", button37,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(button37);
	gtk_container_add(GTK_CONTAINER(hbuttonbox10), button37);
	GTK_WIDGET_SET_FLAGS(button37, GTK_CAN_DEFAULT);

	button38 = gtk_button_new_with_label(_("Cancel"));
	gtk_widget_ref(button38);
	gtk_object_set_data_full(GTK_OBJECT(firstWindow), "button38", button38,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(button38);
	gtk_container_add(GTK_CONTAINER(hbuttonbox10), button38);
	GTK_WIDGET_SET_FLAGS(button38, GTK_CAN_DEFAULT);

	gtk_signal_connect(GTK_OBJECT(button37), "clicked",
		GTK_SIGNAL_FUNC(on_button_firstWindow_ok_clicked), NULL);

	gtk_signal_connect(GTK_OBJECT(button38), "clicked",
		GTK_SIGNAL_FUNC(on_button_firstWindow_cancel_clicked), NULL);

	gtk_signal_connect(GTK_OBJECT(firstWindow), "destroy",
		GTK_SIGNAL_FUNC(on_button_firstWindow_cancel_clicked), NULL);

	gtk_widget_show(firstWindow);

	return firstWindow;
}

void create_window_dialog(char *windowTxt)
{
	GtkWidget *dialog_vbox2;
	GtkWidget *label2;
	GtkWidget *dialog_action_area2;
	GtkWidget *button7;

	window_dialog = gtk_dialog_new();
	gtk_widget_ref(window_dialog);
	gtk_object_set_data_full(GTK_OBJECT(window_dialog), "window_dialog",
		window_dialog, (GtkDestroyNotify) gtk_widget_unref);
	gtk_window_set_title(GTK_WINDOW(window_dialog), _("XSST Window"));
	gtk_window_set_position(GTK_WINDOW(window_dialog), GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(window_dialog), TRUE, TRUE, FALSE);

	dialog_vbox2 = GTK_DIALOG(window_dialog)->vbox;
	gtk_widget_ref(dialog_vbox2);
	gtk_object_set_data_full(GTK_OBJECT(window_dialog), "dialog_vbox2",
		dialog_vbox2, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(dialog_vbox2);
	gtk_container_set_border_width(GTK_CONTAINER(dialog_vbox2), 2);

	label2 = gtk_label_new(_((guchar *) windowTxt));
	gtk_widget_ref(label2);
	gtk_object_set_data_full(GTK_OBJECT(window_dialog), "label2", label2,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(label2);
	gtk_box_pack_start(GTK_BOX(dialog_vbox2), label2, TRUE, TRUE, 10);
	gtk_misc_set_padding(GTK_MISC(label2), 12, 0);

	dialog_action_area2 = GTK_DIALOG(window_dialog)->action_area;
	gtk_widget_ref(dialog_action_area2);
	gtk_object_set_data_full(GTK_OBJECT(window_dialog), "dialog_action_area2",
		dialog_action_area2, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(dialog_action_area2);
	gtk_container_set_border_width(GTK_CONTAINER(dialog_action_area2), 10);

	button7 = gtk_button_new_with_label(_("  OK  "));
	gtk_widget_ref(button7);
	gtk_object_set_data_full(GTK_OBJECT(window_dialog), "button7", button7,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(button7);
	gtk_box_pack_start(GTK_BOX(dialog_action_area2), button7, FALSE, FALSE,
		0);
	GTK_WIDGET_SET_FLAGS(button7, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(button7);

	gtk_signal_connect(GTK_OBJECT(button7), "clicked",
		GTK_SIGNAL_FUNC(on_window_dialog_ok_clicked), NULL);

	gtk_widget_show(window_dialog);
}

void create_window_choice(int callerNumber, char *windowTxt,
	gchar * button1Txt, gchar * button2Txt)
{
	GtkWidget *dialog_vbox2;
	GtkWidget *label2;
	GtkWidget *dialog_action_area2;
	GtkWidget *button7;
	GtkWidget *button8;

	window_dialog = gtk_dialog_new();
	gtk_widget_ref(window_dialog);
	gtk_object_set_data_full(GTK_OBJECT(window_dialog), "window_dialog",
		window_dialog, (GtkDestroyNotify) gtk_widget_unref);
	gtk_window_set_title(GTK_WINDOW(window_dialog), _("XSST Window"));
	gtk_window_set_position(GTK_WINDOW(window_dialog), GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(window_dialog), TRUE, TRUE, FALSE);

	dialog_vbox2 = GTK_DIALOG(window_dialog)->vbox;
	gtk_widget_ref(dialog_vbox2);
	gtk_object_set_data_full(GTK_OBJECT(window_dialog), "dialog_vbox2",
		dialog_vbox2, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(dialog_vbox2);
	gtk_container_set_border_width(GTK_CONTAINER(dialog_vbox2), 2);

	label2 = gtk_label_new(_((guchar *) windowTxt));
	gtk_widget_ref(label2);
	gtk_object_set_data_full(GTK_OBJECT(window_dialog), "label2", label2,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(label2);
	gtk_box_pack_start(GTK_BOX(dialog_vbox2), label2, TRUE, TRUE, 10);
	gtk_misc_set_padding(GTK_MISC(label2), 12, 0);

	dialog_action_area2 = GTK_DIALOG(window_dialog)->action_area;
	gtk_widget_ref(dialog_action_area2);
	gtk_object_set_data_full(GTK_OBJECT(window_dialog), "dialog_action_area2",
		dialog_action_area2, (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(dialog_action_area2);
	gtk_container_set_border_width(GTK_CONTAINER(dialog_action_area2), 10);

	button7 = gtk_button_new_with_label(_(button1Txt));
	gtk_widget_ref(button7);
	gtk_object_set_data_full(GTK_OBJECT(window_dialog), "button7", button7,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(button7);
	gtk_box_pack_start(GTK_BOX(dialog_action_area2), button7, FALSE, FALSE,
		0);
	GTK_WIDGET_SET_FLAGS(button7, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(button7);

	button8 = gtk_button_new_with_label(_(button2Txt));
	gtk_widget_ref(button8);
	gtk_object_set_data_full(GTK_OBJECT(window_dialog), "button8", button8,
		(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(button8);
	gtk_box_pack_start(GTK_BOX(dialog_action_area2), button8, FALSE, FALSE,
		0);
	GTK_WIDGET_SET_FLAGS(button8, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(button8);

	switch (callerNumber)
	{
	case CREATE_USER:
		gtk_signal_connect(GTK_OBJECT(button7), "clicked",
			GTK_SIGNAL_FUNC(on_window_choice_button1_clicked_for_create_user),
			NULL);

		gtk_signal_connect(GTK_OBJECT(button8), "clicked",
			GTK_SIGNAL_FUNC(on_window_choice_button2_clicked_for_create_user),
			NULL);
		break;

	case NEW_DB:
		gtk_signal_connect(GTK_OBJECT(button7), "clicked",
			GTK_SIGNAL_FUNC(on_window_choice_button1_clicked_for_new_db),
			NULL);

		gtk_signal_connect(GTK_OBJECT(button8), "clicked",
			GTK_SIGNAL_FUNC(on_window_choice_button2_clicked_for_new_db),
			NULL);
		break;

	case CREATE_NEXT:
		gtk_signal_connect(GTK_OBJECT(button7), "clicked",
			GTK_SIGNAL_FUNC(on_window_choice_button1_clicked_for_create_next),
			NULL);

		gtk_signal_connect(GTK_OBJECT(button8), "clicked",
			GTK_SIGNAL_FUNC(on_window_choice_button2_clicked_for_create_next),
			NULL);
		break;
	}

	gtk_widget_show(window_dialog);
}

